Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/CPLEX/CplexContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/CPLEX/CplexContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/CPLEX/CplexContext.cs	(revision 15616)
@@ -26,4 +26,5 @@
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.CPLEX {
   [Item("CPLEX Context", "A context for CPLEX solvers.")]
+  [StorableClass]
   public class CplexContext : SingleSolutionContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
     
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Evolutionary/ESGQAPSolution.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Evolutionary/ESGQAPSolution.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Evolutionary/ESGQAPSolution.cs	(revision 15616)
@@ -27,6 +27,6 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.Evolutionary {
+  [Item("ES-specific GQAP Solution", "GQAP Solution that holds a strategy parameter")]
   [StorableClass]
-  [Item("ES-specific GQAP Solution", "GQAP Solution that holds a strategy parameter")]
   public class ESGQAPSolution : GQAPSolution {
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASP.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASP.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/GRASP/GRASP.cs	(revision 15616)
@@ -161,6 +161,4 @@
       Results.Add(new Result("BestQuality", new DoubleValue(Context.BestQuality)));
       Results.Add(new Result("BestSolution", typeof(GQAPSolution)));
-
-      Context.RunOperator(Analyzer, cancellationToken);
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/BasicContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/BasicContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/BasicContext.cs	(revision 15616)
@@ -30,4 +30,6 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
+  [Item("Basic Context", "A base class for algorithms' contexts.")]
+  [StorableClass]
   public class BasicContext : ParameterizedNamedItem, IContext {
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/PopulationContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/PopulationContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/PopulationContext.cs	(revision 15616)
@@ -28,4 +28,5 @@
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Population Context", "A context for population-based algorithms.")]
+  [StorableClass]
   public abstract class PopulationContext<TSolutionScope> : StochasticContext
     where TSolutionScope: class, IScope {
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/SingleSolutionContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/SingleSolutionContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/SingleSolutionContext.cs	(revision 15616)
@@ -26,4 +26,5 @@
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
   [Item("Single Solution Context", "A context for single solution algorithms.")]
+  [StorableClass]
   public abstract class SingleSolutionContext<TSolutionScope> : StochasticContext
     where TSolutionScope: class, IScope {
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/StochasticContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/StochasticContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/Infrastructure/Contexts/StochasticContext.cs	(revision 15616)
@@ -26,4 +26,6 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
+  [Item("Stochastic Context", "A base class for stochastic algorithms' contexts.")]
+  [StorableClass]
   public class StochasticContext : BasicContext, IStochasticContext {
     
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LAHC/LAHCContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LAHC/LAHCContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LAHC/LAHCContext.cs	(revision 15616)
@@ -27,4 +27,6 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.LAHC {
+  [Item("LAHC Context", "Context for late-acceptance hill climber")]
+  [StorableClass]
   public sealed class LAHCContext : SingleSolutionContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
     [Storable]
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LAHC/pLAHCContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LAHC/pLAHCContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LAHC/pLAHCContext.cs	(revision 15616)
@@ -27,4 +27,6 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.LAHC {
+  [Item("pLAHC-s Context", "Context for parameterless late-acceptance hill climber with seeding.")]
+  [StorableClass]
   public sealed class PLAHCContext : SingleSolutionContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
     [Storable]
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LocalSearch/LocalSearchContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LocalSearch/LocalSearchContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LocalSearch/LocalSearchContext.cs	(revision 15616)
@@ -26,4 +26,6 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.LocalSearch {
+  [Item("Local Search Context", "Context for local search algorithms.")]
+  [StorableClass]
   public sealed class LocalSearchContext : SingleSolutionContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
     [Storable]
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LocalSolverNet/LocalSolverContext.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LocalSolverNet/LocalSolverContext.cs	(revision 15615)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms/3.3/LocalSolverNet/LocalSolverContext.cs	(revision 15616)
@@ -27,4 +27,5 @@
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms.LocalSolverNet {
   [Item("LocalSolver Context", "A context for CPLEX solvers.")]
+  [StorableClass]
   public class LocalSolverContext : SingleSolutionContext<ISingleObjectiveSolutionScope<GQAPSolution>> {
 